#ifndef control_RS232
#define control_RS232
#include <windows.h>
#include <iostream>
#include <stdio.h>
#include <string>
#include <conio.h>
#include <ctype.h>
#include "command.h"

using namespace std;

/**
 ** RS232 Control class
 ** Original from Rico Moeckel
 **/

class RS232_control
{
public:
	RS232_control();
	~RS232_control();

	bool valid(){ return valid_; };
	
	bool open();
	void init();
	bool write_data(unsigned char *data, int n_bytes);
	bool read_data(unsigned char * inputData, int size, DWORD * length);
	bool enableTimeout(bool val);
	bool close();
	bool isTimeoutEnabled(){return timeoutEnabled;};

private:
	bool valid_;
	char con;
	char timeoutEnabled;
//	-------------------------------------------------------------------------------
	const char *port;				/* Portname: "COM1, LPT1" */
	char *data;						/* Data to write to port. */
	int bytes_data;					/* Counts bytes in message.*/
	int bytes_written;				/* Counts bytes written.  */
	int transmit_status;            /* Return code from function calls. */
	char input[1];

	/* Control Settings for RS232 */
	
	DWORD baudrate;					// sets baudrate
	DWORD parity_checking;			// enable parity checking (1 = ON)
	DWORD RTS_hardware;				// RTS flow control (0 = Hardware-Handshake)
	BYTE ByteSize;					// number of bits/byte, 4-8 
	BYTE Parity;					// 0-4=no,odd,even,mark,space 
  BYTE StopBits;					// 0,1,2 = 1, 1.5, 2 
	
	HANDLE hPort;					/* Handle to IO port object. */
	BOOL hPort_ready;				/* Return value of CreateFile*/
	DCB  com1_state;				/* Device Control Block-Handle */
	COMMTIMEOUTS  com1_timeouts;	/*S Set timeout-paramters */
	DWORD iBytesWritten;

};


#endif