#ifndef _COMMAND
#define _COMMAND

#include <vector>
#include <assert.h>

using namespace std;

class Command
{
public:

	// A textual representation of the command
	string commandName;
	
	string Command::toString()
	{
  	return commandName;
	}

	// The number of bytes in the command
	int Command::getLength()
	{
		return (int)command_bytes.size();
	}

	vector<byte> Command::getCommand()
	{
		return command_bytes;
	}
	
	Command::Command(string commandName, int size, byte x, ...)
	{
		this->commandName = commandName;

		va_list list;	

		// Initialize the list of arguments
    va_start(list,x); 

		assert(size >= 1);

		// Retrieve first argument
		command_bytes.push_back(x);

		for(int i = 0; i < size-1; i++)
		{
			// Retrieve arguments
			byte t = va_arg(list, byte);			
			command_bytes.push_back(t);
		}
    		
    va_end(list); 
	}

private:
	// Stores the bytes of the command 
	vector<byte> command_bytes;
	
};

#endif